from random import Random

ENTER = 0
LEAVE = 1
WIN_EASY = 2
WIN_HARD = 3

def _make_events(customers, main=False):
    events = []
    internal_id = 0
    for begin, length, types in sorted(customers):
        internal_id += 1
        events.append((begin, ENTER, internal_id, types, begin+length))
        events.append((begin+length, LEAVE, internal_id, None, None))
    if main:
        events.append((60*60, WIN_EASY, None, None, None))
        events.append((3*60*60, WIN_HARD, None, None, None))
    events.sort()
    times = [e[0] for e in events]
    return { "events": events, "times": times }

def _get_main_tier():
    r = Random(1913274)

    customers = []

#    for i in range(5):
#        customers.append((5+i*10, 600, ['roman']))
#    for i in range(30):
#        customers.append((5+i*2, 600, ['ipschuman']))
#    return _make_events(customers, main=True)

#    customers.append((6, 600, ['identity']))
#    customers.append((6, 600, ['substr']))
#    customers.append((6, 600, ['reverse']))
#    customers.append((6, 600, ['not']))
#    customers.append((6, 600, ['eval']))
#    customers.append((6, 600, ['sqrt']))
#    customers.append((6, 600, ['factorial']))
#    customers.append((6, 600, ['parentheses']))
#    customers.append((6, 600, ['hexominoes']))
#    customers.append((6, 600, ['tictactoe']))
#    customers.append((6, 600, ['components']))
#    return _make_events(customers, main=True)

    customers.append((4, 90, ['identity']))
    customers.append((12, 90, ['identity']))
    customers.append((29, 90, ['identity']))
    customers.append((29, 90, ['identity']))

    customers.append((6*60 + r.randint(-15, 15), 90, ['identity']))
    customers.append((6*60 + r.randint(-15, 15), 90, ['identity']))
    customers.append((7*60 + r.randint(-15, 15), 90, ['reverse']))

    t = r.randint(10*60, 11*60)
    types = ['identity', 'reverse']
    customers.append((t, 60, types))
    customers.append((t, 60, types))
    customers.append((t, 60, types))

    t = r.randint(19*60, 21*60)
    customers.append((t, 60, types))
    customers.append((t, 60, types))
    customers.append((t, 60, types))
    t = r.randint(19*60, 21*60)
    customers.append((t, 60, types))
    customers.append((t, 60, types))

    customers.append((r.randint(24*60, 25*60), 60, types))
    customers.append((r.randint(24*60, 25*60), 60, ['substr']))
    types = types + ['substr']

    for t in range(30*60, 33*60, 17):
        customers.append((t + r.randint(-7, 7), 60, types))

    for t in range(38*60, 41*60, 12):
        customers.append((t + r.randint(-7, 7), 60, types))

    customers.append((46*60 + r.randint(-15, 15), 120, ['not']))
    types2 = types + ['not']
    for t in range(46*60, 49*60, 11):
        customers.append((t + r.randint(-15, 15), 60, types2 if t > 54*60 else types))
    for t in range(49*60, 58*60+30, 7):
        customers.append((t + r.randint(-15, 15), 60, types2 if t > 54*60 else types))

#    customers.sort()
#    print(len(customers))
#    for x,y,z in customers: print(x//60,x%60,y,z)

    # hard

    customers.append((r.randint(65*60, 66*60), 120, ['sqrt']))
    customers.append((r.randint(70*60, 71*60), 120, ['factorial']))
    types = types2 + ['sqrt', 'factorial']

    for m in range(0, 15, 3):
        t = 75*60 + m*60 + r.randint(0, 60)
        if m == 6: types = types + ['eval']
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, ['eval'] if m == 0 or m == 3 else types))
    for m in range(0, 15, 3):
        t = 90*60 + m*60 + r.randint(0, 60)
        if m == 6: types = types + ['parentheses']
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, ['parentheses'] if m == 0 or m == 3 else types))
    for m in range(0, 15, 2):
        t = 105*60 + m*60 + r.randint(0, 60)
        if m == 6: types = types + ['tictactoe']
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, ['tictactoe'] if m == 0 or m == 2 else types))
    for m in range(0, 15, 2):
        t = 120*60 + m*60 + r.randint(0, 60)
        if m == 6: types = types + ['components']
        customers.append((t, 60, types))
        customers.append((t, 60, types))
        customers.append((t, 60, ['components'] if m == 0 or m == 2 else types))
    for m in range(15):
        t = 135*60 + m*60 + r.randint(0, 60)
        if m == 6: types = types + ['hexominoes']
        customers.append((t, 60, ['hexominoes'] if m == 0 or m == 3 else types))
    for m in range(29):
        customers.append((150*60 + m*60 + r.randint(0, 60), 60, types))
        customers.append((150*60 + m*60 + r.randint(0, 60), 60, types))
        customers.append((150*60 + m*60 + r.randint(0, 60), 60, types))
        customers.append((150*60 + m*60 + r.randint(0, 60), 60, types))
        customers.append((150*60 + m*60 + r.randint(0, 60), 60, types))

#    customers.sort()
#    print(len(customers))
#    for x,y,z in customers: print(x//60,x%60,y,z)

#    easy_types = ['identity', 'reverse', 'substr', 'not']
#    all_types = ['identity', 'substr', 'reverse', 'eval', 'sqrt', 'factorial']
#    for minute in range(5, 60, 5):
#        for i in range(3):
#            customers.append((minute*60, 60, all_types))
#    for sec in range(0, 30*60, 15):
#        customers.append((sec, 60, ['identity', 'reverse', 'substr']))#'identity', 'substr', 'reverse']))
    return _make_events(customers, main=True)

def _get_humans_tier():
    r = Random(1913213)

    customers = []

    for m in range(5, 180, 5):
        customers.append((m*60, 5*60-10, ['ipschuman']))

    for m in range(0, 180, 10):
        customers.append((m*60+r.randint(10,10*60), 2*60, ['roman']))
        customers.append((m*60+r.randint(10,10*60), 2*60, ['roman']))
        customers.append((m*60+r.randint(10,10*60), 2*60, ['roman']))

#    customers.sort()
#    print(len(customers))
#    for x,y,z in customers: print(x//60,x%60,y,z)

    return _make_events(customers)

tiers = {
    "main": _get_main_tier(),
    "humans": _get_humans_tier(),
}
