import random

SIZE = 5

def safe_to_place(data, x, y, ok=None):
    for xx in range(x-1, x+2):
        for yy in range(y-1, y+2):
            if xx < 0 or xx >= SIZE:
                continue
            if yy < 0 or yy >= SIZE:
                continue
            if data[xx][yy] and data[xx][yy] != ok:
                return False
    return True

def gen_initial():
    data = [[0 for j in range(SIZE)] for i in range(SIZE)]

    cnt = random.randint(1, 5)
    filled = []
    breaker = 0
    for i in range(1, cnt + 1):
        while True:
            breaker += 1
            if breaker > 200: # could get stuck with 5 components
                return None, None, None
            x = random.randint(0, SIZE-1)
            y = random.randint(0, SIZE-1)
            if safe_to_place(data, x, y):
                data[x][y] = i
                filled.append((x, y, i))
                break
    return data, cnt, filled

def task_components():
    while True:
        data, cnt, filled = gen_initial()
        if data:
            break

    for _ in range(SIZE*SIZE):
        x, y, i = random.choice(filled)
        dx, dy = random.choice([(0, 1), (0, -1), (1, 0), (-1, 0)])
        x += dx
        y += dy
        if x < 0 or x >= SIZE:
            continue
        if y < 0 or y >= SIZE:
            continue
        if data[x][y]:
            continue # already filled
        if not safe_to_place(data, x, y, i):
            continue
        data[x][y] = i
        filled.append((x, y, i))

    data = "\n".join("".join(str('#' if x else '.') for x in line) for line in data)
    return {"var1": data, "answer": bin(cnt).replace("0b", "")}
