import random

# Let's believe in
# https://en.wikipedia.org/wiki/Hexomino#/media/File:All_35_free_hexominoes.svg
HEXIMONOES = """
............................................
.1..........................................
.1.....66....B.....G......L.................
.1.....6.....BB....G.....LL....QQ....VV.....
.1.....6.....B.....GG....L.....QQ....V......
.1.....6.....B.....G.....L.....Q.....VV.....
.1.....6.....B.....G.....L.....Q.....V......
............................................
.22....7.....CCC...H.....MMM....RR...WW.....
.2.....77....C.....HHH....M....RR...WW......
.2.....77....C.....H......M.....R....W......
.22....7.....C.....H......M.....R....W......
............................................
..33....8.....D.....I.....N.....S......X....
..3.....88...DDD...III...NN.....S.....XX....
..3....88.....D....I.....N.....SS.....XX....
.33.....8.....D....I.....NN....S......X.....
...............................S............
.........9...........J.....O.....TT...YYY...
.44....999...EEE....JJ...OOO....TT....Y.Y...
.44.....9.....EE...JJ....O......T.....Y.....
.44.....9.....E.....J....O......T...........
............................................
..............FF........................Z...
.5.5...A.A....F....K......P.......U....ZZ...
.555...AAA...FF....KK....PPP....UUU...ZZ....
.5......A....F.....KKK...PP.....UU....Z.....
............................................
"""

HEXOMINO_KEYS = "123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
assert len(HEXOMINO_KEYS) == 35


def get_hexomino(c):
    def transpose(data):
        return zip(*data)

    def flip(data):
        return [list(reversed(line)) for line in data]

    lines = HEXIMONOES.split()
    lines = [l for l in lines if c in l]
    lines = transpose(lines)
    lines = [l for l in lines if c in l]

    for i in range(random.randint(0, 10)):
        if random.randint(0, 1):
            lines = transpose(lines)
        if random.randint(0, 1):
            lines = flip(lines)

    data = ["".join(line) for line in lines]
    data = [line.replace(c, '@') for line in data]
    return "\n".join(data)


def task_hexominoes():
    h1 = random.choice(HEXOMINO_KEYS)
    if random.randint(0, 1):
        h2 = random.choice(HEXOMINO_KEYS)
    else:
        h2 = h1

    data1 = get_hexomino(h1)
    data2 = get_hexomino(h2)

    return {
        "var1": data1, "var2": data2,
        "answer": "yes" if h1 == h2 else "no",
    }
