import random


def gen_tictac():
    # We need to be a bit careful to generate only valid games
    board = [['.', '.', '.'] for _ in range(3)]
    nxt = lambda c: 'X' if c == 'O' else 'O'

    c = random.choice("XO")

    for i in range(random.randint(5, 9)):
        while True: # pick random unused square
            x = random.randint(0, 2)
            y = random.randint(0, 2)
            if board[x][y] == '.':
                break

        board[x][y] = c
        c = nxt(c)
        
        x = check_tictac(board, 'X')
        o = check_tictac(board, 'O')
        if x or o:
            break # game end
    return ["".join(line) for line in board]

def check_tictac(board, c):
    for i in range(3):
        if board[i][0] == c and board[i][1] == c and board[i][2] == c:
            return True

    for i in range(3):
        if board[0][i] == c and board[1][i] == c and board[2][i] == c:
            return True

    if all(board[i][i] == c for i in range(3)):
        return True

    if all(board[i][2-i] == c for i in range(3)):
        return True

    return False


def task_tictactoe():
    ans = random.randint(0, 2)
    while True:
        board = gen_tictac()
        x = check_tictac(board, 'X')
        o = check_tictac(board, 'O')
        board = "\n".join(board)

        if x and o:
            continue # invalid play
        if ans == 0 and not x and not o:
            return {"var1": board, "answer": "NEITHER"}
        if ans == 1 and x and not o:
            return {"var1": board, "answer": "X"}
        if ans == 2 and not x and o:
            return {"var1": board, "answer": "O"}
        # try another iteration
