import json
import mimetypes
import time
import os
from werkzeug.exceptions import HTTPException, NotFound
from werkzeug.wrappers import Request, Response
from werkzeug.utils import redirect
from m.logic import process

state = None

contest_start = int(time.time())

files = os.listdir('.')

def serve_static(file):
    try:
        with open(file, 'rb') as f:
            content = f.read()
    except FileNotFoundError:
        return NotFound()
    return Response(content, content_type=mimetypes.guess_type(file)[0], headers={ 'Cache-Control': 'no-cache' })

@Request.application
def application(request):
    global state
    if request.path == '/m_api':
        real_time = int(time.time())
        contest_time = real_time - contest_start
        response, state, ok1, ok2 = process(state, request.form, real_time, contest_time)
        return Response(json.dumps(response, sort_keys=True), content_type='application/json')
    if request.path == '/':
        return serve_static('test_client.html')
    if request.path.startswith('/') and request.path[1:] in files:
        return serve_static(request.path[1:])
    return NotFound()


if __name__ == '__main__':
    import m.logic
    m.logic.TASK_DEBUG = True

    from werkzeug.serving import run_simple
    run_simple('localhost', 4000, application, use_reloader=False, use_debugger=True)
